\echo ###### Prepare for the test
\set QUIET
SET client_min_messages = 'error';
CREATE EXTENSION IF NOT EXISTS pg_store_plans;
DROP TABLE IF EXISTS plans;
CREATE TABLE plans (id int, title text, lplan text, splan text);
SET client_min_messages = 'notice';
\set ECHO none

\echo ###### insert original JSON plans
INSERT INTO plans (VALUES
(-1, '###### Plan -1: all properties',
 '{
  "Plan": 0,
  "Plans": 0,
  "Node Type": "Result",
  "Node Type": "ModifyTable",
  "Node Type": "Append",
  "Node Type": "Merge Append",
  "Node Type": "Recursive Union",
  "Node Type": "BitmapAnd",
  "Node Type": "BitmapOr",
  "Node Type": "Seq Scan",
  "Node Type": "Index Scan",
  "Node Type": "Index Only Scan",
  "Node Type": "Bitmap Index Scan",
  "Node Type": "Bitmap Heap Scan",
  "Node Type": "Tid Scan",
  "Node Type": "Subquery Scan",
  "Node Type": "Function Scan",
  "Node Type": "Values Scan",
  "Node Type": "CTE Scan",
  "Node Type": "WorkTable Scan",
  "Node Type": "Foreign Scan",
  "Node Type": "Nested Loop",
  "Node Type": "Merge Join",
  "Node Type": "Hash Join",
  "Node Type": "Materialize",
  "Node Type": "Sort",
  "Node Type": "Group",
  "Node Type": "Aggregate",
  "Node Type": "WindowAgg",
  "Node Type": "Unique",
  "Node Type": "Hash",
  "Node Type": "SetOp",
  "Node Type": "LockRows",
  "Node Type": "Limit",
  "Parent Relationship": "Outer",
  "Parent Relationship": "Inner",
  "Parent Relationship": "Subquery",
  "Parent Relationship": "Member",
  "Parent Relationship": "InitPlan",
  "Parent Relationship": "SubPlan",
  "Scan Direction": "Backward",
  "Scan Direction": "NoMovement",
  "Scan Direction": "Forward",
  "Index Name": 0,
  "Relation Name": 0,
  "Function Name": 0,
  "CTE Name": 0,
  "Schema": 0,
  "Alias": 0,
  "Output": "[]",
  "Merge Cond": "a",
  "Strategy": "Plain",
  "Strategy": "Sorted",
  "Strategy": "Hashed",
  "Join Type": "Inner",
  "Join Type": "Left",
  "Join Type": "Full",
  "Join Type": "Right",
  "Join Type": "Semi",
  "Join Type": "Anti",
  "Command": "Intersect",
  "Command": "Intersect All",
  "Command": "Except",
  "Command": "Except All",
  "Sort Method": "top-N heapsort",
  "Sort Method": "quicksort",
  "Sort Method": "external sort",
  "Sort Method": "external merge",
  "Sort Method": "still in progress",
  "Sort Key": "a",
  "Filter": "a",
  "Join Filter": "a",
  "Hash Cond": "a",
  "Index Cond": "a",
  "TID Cond": "a",
  "Recheck Cond": "a",
  "Operation": "Insert",
  "Operation": "Delete",
  "Operation": "Update",
  "Subplan Name": "a",
  "Triggers": 0,
  "Trigger": 0,
  "Trigger Name": 0,
  "Relation": 0,
  "Constraint Name": 0,
  "Function Call": 0,
  "Startup Cost": 0,
  "Total Cost": 0,
  "Plan Rows": 0,
  "Plan Width": 0,
  "Actual Startup Time": 0,
  "Actual Total Time": 0,
  "Actual Rows": 0,
  "Actual Loops": 0,
  "Heap Fetches": 0,
  "Shared Hit Blocks": 0,
  "Shared Read Blocks": 0,
  "Shared Dirtied Blocks": 0,
  "Shared Written Blocks": 0,
  "Local Hit Blocks": 0,
  "Local Read Blocks": 0,
  "Local Dirtied Blocks": 0,
  "Local Written Blocks": 0,
  "Temp Read Blocks": 0,
  "Temp Written Blocks": 0,
  "I/O Read Time": 0,
  "I/O Write Time": 0,
  "Sort Space Used": 0,
  "Sort Space Type": "Disk",
  "Sort Space Type": "Memory",
  "Peak Memory Usage": 0,
  "Original Hash Batches": 0,
  "Hash Batches": 0,
  "Hash Buckets": 0,
  "Rows Removed by Filter": 0,
  "Rows Removed by Index Recheck": 0,
  "Time": 0,
  "Calls": 0,
  "Planning Time": 0,
  "Execution Time": 0,
  "Exact Heap Blocks": 0,
  "Lossy Heap Blocks": 0,
  "Rows Removed by Join Filter": 0
}'),(-2, '###### Plan -2: all properties plus unknown key',
 '{
  "Plan": 0,
  "Plans": 0,
  "Node Type": "Result",
  "Node Type": "ModifyTable",
  "Node Type": "Append",
  "Node Type": "Merge Append",
  "Node Type": "Recursive Union",
  "Node Type": "BitmapAnd",
  "Node Type": "BitmapOr",
  "Node Type": "Seq Scan",
  "Node Type": "Index Scan",
  "Node Type": "Index Only Scan",
  "Node Type": "Bitmap Index Scan",
  "Node Type": "Bitmap Heap Scan",
  "Node Type": "Tid Scan",
  "Node Type": "Subquery Scan",
  "Node Type": "Function Scan",
  "Node Type": "Values Scan",
  "Node Type": "CTE Scan",
  "Node Type": "WorkTable Scan",
  "Node Type": "Foreign Scan",
  "Node Type": "Nested Loop",
  "Node Type": "Merge Join",
  "Node Type": "Hash Join",
  "Node Type": "Materialize",
  "Node Type": "Sort",
  "Node Type": "Group",
  "Node Type": "Aggregate",
  "Node Type": "WindowAgg",
  "Node Type": "Unique",
  "Node Type": "Hash",
  "Node Type": "SetOp",
  "Node Type": "LockRows",
  "Node Type": "Limit",
  "Parent Relationship": "Outer",
  "Parent Relationship": "Inner",
  "Parent Relationship": "Subquery",
  "Parent Relationship": "Member",
  "Parent Relationship": "InitPlan",
  "Parent Relationship": "SubPlan",
  "Scan Direction": "Backward",
  "Scan Direction": "NoMovement",
  "Scan Direction": "Forward",
  "Index Name": 0,
  "Relation Name": 0,
  "Function Name": 0,
  "CTE Name": 0,
  "Schema": 0,
  "Alias": 0,
  "Output": "[]",
  "Merge Cond": "a",
  "Strategy": "Plain",
  "Strategy": "Sorted",
  "Strategy": "Hashed",
  "Join Type": "Inner",
  "Join Type": "Left",
  "Join Type": "Full",
  "Join Type": "Right",
  "Join Type": "Semi",
  "Join Type": "Anti",
  "Command": "Intersect",
  "Command": "Intersect All",
  "Command": "Except",
  "Command": "Except All",
  "Sort Method": "top-N heapsort",
  "Sort Method": "quicksort",
  "Sort Method": "external sort",
  "Sort Method": "external merge",
  "Sort Method": "still in progress",
  "Sort Key": "a",
  "Filter": "a",
  "Join Filter": "a",
  "Hash Cond": "a",
  "Index Cond": "a",
  "TID Cond": "a",
  "Recheck Cond": "a",
  "Operation": "Insert",
  "Operation": "Delete",
  "Operation": "Update",
  "Subplan Name": "a",
  "Triggers": 0,
  "Trigger": 0,
  "Trigger Name": 0,
  "Relation": 0,
  "Constraint Name": 0,
  "Function Call": 0,
  "Startup Cost": 0,
  "Total Cost": 0,
  "Plan Rows": 0,
  "Plan Width": 0,
  "Actual Startup Time": 0,
  "Actual Total Time": 0,
  "Actual Rows": 0,
  "Actual Loops": 0,
  "Heap Fetches": 0,
  "Shared Hit Blocks": 0,
  "Shared Read Blocks": 0,
  "Shared Dirtied Blocks": 0,
  "Shared Written Blocks": 0,
  "Local Hit Blocks": 0,
  "Local Read Blocks": 0,
  "Local Dirtied Blocks": 0,
  "Local Written Blocks": 0,
  "Temp Read Blocks": 0,
  "Temp Written Blocks": 0,
  "I/O Read Time": 0,
  "I/O Write Time": 0,
  "Sort Space Used": 0,
  "Sort Space Type": "Disk",
  "Sort Space Type": "Memory",
  "Peak Memory Usage": 0,
  "Original Hash Batches": 0,
  "Hash Batches": 0,
  "Hash Buckets": 0,
  "Rows Removed by Filter": 0,
  "Rows Removed by Index Recheck": 0,
  "Time": 0,
  "Calls": 0,
  "Planning Time": 0,
  "Execution Time": 0,
  "Exact Heap Blocks": 0,
  "Lossy Heap Blocks": 0,
  "Rows Removed by Join Filter": 0,
  "Unknown Key": "Unknown Value"
}'),
(1, '###### Plan 1: Insert, Trigger',
 '{
  "Plan": {
    "Node Type": "ModifyTable",
    "Operation": "Insert",
    "Relation Name": "tt1",
    "Schema": "public",
    "Alias": "tt1",
    "Startup Cost": 0.00,
    "Total Cost": 10.00,
    "Plan Rows": 1000,
    "Plan Width": 4,
    "Actual Startup Time": 278.453,
    "Actual Total Time": 278.453,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Shared Hit Blocks": 29735,
    "Shared Read Blocks": 87,
    "Shared Dirtied Blocks": 85,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Function Scan",
        "Parent Relationship": "Member",
        "Function Name": "generate_series",
        "Schema": "pg_catalog",
        "Alias": "a",
        "Startup Cost": 0.00,
        "Total Cost": 10.00,
        "Plan Rows": 1000,
        "Plan Width": 4,
        "Actual Startup Time": 3.470,
        "Actual Total Time": 9.319,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["a.a", "NULL::integer", "NULL::text"],
        "Function Call": "generate_series(0, 10000)",
        "Shared Hit Blocks": 0,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000
      }
    ]
  },
  "Planning Time": 0.072,
  "Triggers": [
    {
      "Trigger Name": "tt1_trig_1",
      "Relation": "tt1",
      "Time": 100.983,
      "Calls": 10001
    },
    {
      "Trigger Name": "tt1_trig_2",
      "Relation": "tt1",
      "Time": 85.683,
      "Calls": 10001
    }
  ],
  "Execution Time": 279.083
}'),
(2, '###### Plan 2: Update, Trigger',
 '{
  "Plan": {
    "Node Type": "ModifyTable",
    "Operation": "Update",
    "Relation Name": "tt1",
    "Schema": "public",
    "Alias": "tt1",
    "Startup Cost": 0.00,
    "Total Cost": 134.75,
    "Plan Rows": 6380,
    "Plan Width": 46,
    "Actual Startup Time": 340.377,
    "Actual Total Time": 340.377,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Shared Hit Blocks": 50276,
    "Shared Read Blocks": 108,
    "Shared Dirtied Blocks": 108,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Member",
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.00,
        "Total Cost": 134.75,
        "Plan Rows": 6380,
        "Plan Width": 46,
        "Actual Startup Time": 0.022,
        "Actual Total Time": 10.544,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["(a + 1)", "b", "c", "ctid"],
        "Shared Hit Blocks": 55,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000
      }
    ]
  },
  "Planning Time": 0.109,
  "Triggers": [
    {
      "Trigger Name": "tt1_trig_1",
      "Relation": "tt1",
      "Time": 106.386,
      "Calls": 10001
    },
    {
      "Trigger Name": "tt1_trig_2",
      "Relation": "tt1",
      "Time": 88.764,
      "Calls": 10001
    }
  ],
  "Execution Time": 340.407
}'),
(3, '###### Plan 3: Delete',
 '{
  "Plan": {
    "Node Type": "ModifyTable",
    "Operation": "Delete",
    "Relation Name": "tt1",
    "Schema": "public",
    "Alias": "tt1",
    "Startup Cost": 0.00,
    "Total Cost": 298.66,
    "Plan Rows": 63,
    "Plan Width": 6,
    "Actual Startup Time": 13.983,
    "Actual Total Time": 13.983,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Shared Hit Blocks": 1109,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Member",
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.00,
        "Total Cost": 298.66,
        "Plan Rows": 63,
        "Plan Width": 6,
        "Actual Startup Time": 3.535,
        "Actual Total Time": 11.047,
        "Actual Rows": 1000,
        "Actual Loops": 1,
        "Output": ["ctid"],
        "Filter": "((tt1.a % 10) = 0)",
        "Rows Removed by Filter": 9001,
        "Shared Hit Blocks": 109,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000
      }
    ]
  },
  "Planning Time": 0.147,
  "Triggers": [
  ],
  "Execution Time": 14.024
}'),
(4, '###### Plan 4: Result, Append Seq Scan',
 '{
  "Plan": {
    "Node Type": "Result",
    "Startup Cost": 0.00,
    "Total Cost": 418.02,
    "Plan Rows": 20002,
    "Plan Width": 8,
    "Actual Startup Time": 2.484,
    "Actual Total Time": 16.162,
    "Actual Rows": 20002,
    "Actual Loops": 1,
    "Output": ["((tt1.a + 1))", "(3)", "1"],
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Append",
        "Parent Relationship": "Outer",
        "Startup Cost": 0.00,
        "Total Cost": 418.02,
        "Plan Rows": 20002,
        "Plan Width": 8,
        "Actual Startup Time": 2.483,
        "Actual Total Time": 11.347,
        "Actual Rows": 20002,
        "Actual Loops": 1,
        "Shared Hit Blocks": 218,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Member",
            "Relation Name": "tt1",
            "Schema": "public",
            "Alias": "tt1",
            "Startup Cost": 0.00,
            "Total Cost": 263.01,
            "Plan Rows": 10001,
            "Plan Width": 8,
            "Actual Startup Time": 2.482,
            "Actual Total Time": 6.131,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["(tt1.a + 1)", "3"],
            "Shared Hit Blocks": 163,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000
          },
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Member",
            "Relation Name": "tt2",
            "Schema": "public",
            "Alias": "tt2",
            "Startup Cost": 0.00,
            "Total Cost": 155.01,
            "Plan Rows": 10001,
            "Plan Width": 8,
            "Actual Startup Time": 0.006,
            "Actual Total Time": 2.478,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["tt2.a", "4"],
            "Shared Hit Blocks": 55,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000
          }
        ]
      }
    ]
  },
  "Planning Time": 0.470,
  "Triggers": [
  ],
  "Execution Time": 17.849
}'),
(5, '###### Plan 5: Index scan (forward) ANY, array in expr, escape',
 E'{
  "Plan": {
    "Node Type": "Index Scan",
    "Scan Direction": "Forward",
    "Index Name": "i_tt1",
    "Relation Name": "tt1",
    "Schema": "public",
    "Alias": "x\\"y",
    "Startup Cost": 0.29,
    "Total Cost": 21.21,
    "Plan Rows": 4,
    "Plan Width": 12,
    "Actual Startup Time": 0.006,
    "Actual Total Time": 0.023,
    "Actual Rows": 4,
    "Actual Loops": 1,
    "Output": ["a", "b", "c"],
    "Index Cond": "(\\"x\\"\\"y\\".a = ANY (\'{50,120,300,500}\'::integer[]))",
    "Rows Removed by Index Recheck": 0,
    "Shared Hit Blocks": 20,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000
  },
  "Planning Time": 0.088,
  "Triggers": [
  ],
  "Execution Time": 0.061
}'),
(6, '###### Plan 6: Index scan (backward), MergeJoin, Sort, quichsort, alias',
 '{
  "Plan": {
    "Node Type": "Limit",
    "Startup Cost": 819.75,
    "Total Cost": 820.79,
    "Plan Rows": 10,
    "Plan Width": 12,
    "Actual Startup Time": 10.948,
    "Actual Total Time": 10.948,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Output": ["x.b", "x.c", "x.a"],
    "Shared Hit Blocks": 61,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Merge Join",
        "Parent Relationship": "Outer",
        "Join Type": "Inner",
        "Startup Cost": 819.75,
        "Total Cost": 1854.80,
        "Plan Rows": 10001,
        "Plan Width": 12,
        "Actual Startup Time": 10.948,
        "Actual Total Time": 10.948,
        "Actual Rows": 0,
        "Actual Loops": 1,
        "Output": ["x.b", "x.c", "x.a"],
        "Merge Cond": "(x.a = (((- y.b) * 3)))",
        "Shared Hit Blocks": 61,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Index Scan",
            "Parent Relationship": "Outer",
            "Scan Direction": "Backward",
            "Index Name": "i_tt1",
            "Relation Name": "tt1",
            "Schema": "public",
            "Alias": "x",
            "Startup Cost": 0.29,
            "Total Cost": 760.30,
            "Plan Rows": 10001,
            "Plan Width": 12,
            "Actual Startup Time": 0.015,
            "Actual Total Time": 0.015,
            "Actual Rows": 1,
            "Actual Loops": 1,
            "Output": ["x.a", "x.b", "x.c"],
            "Shared Hit Blocks": 6,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000
          },
          {
            "Node Type": "Sort",
            "Parent Relationship": "Inner",
            "Startup Cost": 819.47,
            "Total Cost": 844.47,
            "Plan Rows": 10001,
            "Plan Width": 4,
            "Actual Startup Time": 8.449,
            "Actual Total Time": 9.138,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["y.b", "(((- y.b) * 3))"],
            "Sort Key": ["(((- y.b) * 3))"],
            "Sort Method": "quicksort",
            "Sort Space Used": 855,
            "Sort Space Type": "Memory",
            "Shared Hit Blocks": 55,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000,
            "Plans": [
              {
                "Node Type": "Seq Scan",
                "Parent Relationship": "Outer",
                "Relation Name": "tt2",
                "Schema": "public",
                "Alias": "y",
                "Startup Cost": 0.00,
                "Total Cost": 155.01,
                "Plan Rows": 10001,
                "Plan Width": 4,
                "Actual Startup Time": 0.008,
                "Actual Total Time": 3.308,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["y.b", "((- y.b) * 3)"],
                "Shared Hit Blocks": 55,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "I/O Read Time": 0.000,
                "I/O Write Time": 0.000
              }
            ]
          }
        ]
      }
    ]
  },
  "Planning Time": 0.214,
  "Triggers": [
  ],
  "Execution Time": 11.162
}'),
(7, '###### Plan 7: IndexOnlyScan',
 '{
  "Plan": {
    "Node Type": "Index Only Scan",
    "Scan Direction": "Forward",
    "Index Name": "i_tt1",
    "Relation Name": "tt1",
    "Schema": "public",
    "Alias": "tt1",
    "Startup Cost": 0.29,
    "Total Cost": 8.46,
    "Plan Rows": 10,
    "Plan Width": 4,
    "Actual Startup Time": 0.016,
    "Actual Total Time": 0.033,
    "Actual Rows": 10,
    "Actual Loops": 1,
    "Output": ["a"],
    "Index Cond": "(tt1.a < 10)",
    "Rows Removed by Index Recheck": 0,
    "Heap Fetches": 29,
    "Shared Hit Blocks": 31,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000
  },
  "Planning Time": 0.063,
  "Triggers": [
  ],
  "Execution Time": 0.051
}'),
(8, '###### Plan 8: Plain Aggregate, CTE, Recursive Union, WorkTable Scan, CTE Scan',
 '{
  "Plan": {
    "Node Type": "Aggregate",
    "Strategy": "Plain",
    "Startup Cost": 3.65,
    "Total Cost": 3.66,
    "Plan Rows": 1,
    "Plan Width": 4,
    "Actual Startup Time": 0.034,
    "Actual Total Time": 0.034,
    "Actual Rows": 1,
    "Actual Loops": 1,
    "Output": ["sum(cte1.a)"],
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Recursive Union",
        "Parent Relationship": "InitPlan",
        "Subplan Name": "CTE cte1",
        "Startup Cost": 0.00,
        "Total Cost": 2.95,
        "Plan Rows": 31,
        "Plan Width": 4,
        "Actual Startup Time": 0.002,
        "Actual Total Time": 0.023,
        "Actual Rows": 10,
        "Actual Loops": 1,
        "Shared Hit Blocks": 0,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Result",
            "Parent Relationship": "Outer",
            "Startup Cost": 0.00,
            "Total Cost": 0.01,
            "Plan Rows": 1,
            "Plan Width": 0,
            "Actual Startup Time": 0.000,
            "Actual Total Time": 0.000,
            "Actual Rows": 1,
            "Actual Loops": 1,
            "Output": ["1"],
            "Shared Hit Blocks": 0,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000
          },
          {
            "Node Type": "WorkTable Scan",
            "Parent Relationship": "Inner",
            "CTE Name": "cte1",
            "Alias": "cte1_1",
            "Startup Cost": 0.00,
            "Total Cost": 0.23,
            "Plan Rows": 3,
            "Plan Width": 4,
            "Actual Startup Time": 0.001,
            "Actual Total Time": 0.001,
            "Actual Rows": 1,
            "Actual Loops": 10,
            "Output": ["(cte1_1.a + 1)"],
            "Filter": "(cte1_1.a < 10)",
            "Rows Removed by Filter": 0,
            "Shared Hit Blocks": 0,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000
          }
        ]
      },
      {
        "Node Type": "CTE Scan",
        "Parent Relationship": "Outer",
        "CTE Name": "cte1",
        "Alias": "cte1",
        "Startup Cost": 0.00,
        "Total Cost": 0.62,
        "Plan Rows": 31,
        "Plan Width": 4,
        "Actual Startup Time": 0.002,
        "Actual Total Time": 0.028,
        "Actual Rows": 10,
        "Actual Loops": 1,
        "Output": ["cte1.a"],
        "Shared Hit Blocks": 0,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000
      }
    ]
  },
  "Planning Time": 0.077,
  "Triggers": [
  ],
  "Execution Time": 0.075
}'),
(9, '###### Plan 9: FunctionScan, Hash/HashJoin, Nested Loop',
 '{
  "Plan": {
    "Node Type": "Nested Loop",
    "Join Type": "Inner",
    "Startup Cost": 1.15,
    "Total Cost": 2.69,
    "Plan Rows": 1,
    "Plan Width": 64,
    "Actual Startup Time": 0.043,
    "Actual Total Time": 0.049,
    "Actual Rows": 2,
    "Actual Loops": 1,
    "Output": ["d.datname"],
    "Shared Hit Blocks": 5,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Hash Join",
        "Parent Relationship": "Outer",
        "Join Type": "Inner",
        "Startup Cost": 1.02,
        "Total Cost": 2.41,
        "Plan Rows": 1,
        "Plan Width": 4,
        "Actual Startup Time": 0.037,
        "Actual Total Time": 0.038,
        "Actual Rows": 2,
        "Actual Loops": 1,
        "Output": ["s.datid"],
        "Hash Cond": "(s.usesysid = u.oid)",
        "Shared Hit Blocks": 1,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Function Scan",
            "Parent Relationship": "Outer",
            "Function Name": "pg_stat_get_activity",
            "Schema": "pg_catalog",
            "Alias": "s",
            "Startup Cost": 0.00,
            "Total Cost": 1.00,
            "Plan Rows": 100,
            "Plan Width": 8,
            "Actual Startup Time": 0.026,
            "Actual Total Time": 0.026,
            "Actual Rows": 2,
            "Actual Loops": 1,
            "Output": ["s.datid", "s.pid", "s.usesysid", "s.application_name", "s.state", "s.query", "s.waiting", "s.xact_start", "s.query_start", "s.backend_start", "s.state_change", "s.client_addr", "s.client_hostname", "s.client_port", "s.backend_xid", "s.backend_xmin"],
            "Function Call": "pg_stat_get_activity(NULL::integer)",
            "Shared Hit Blocks": 0,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000
          },
          {
            "Node Type": "Hash",
            "Parent Relationship": "Inner",
            "Startup Cost": 1.01,
            "Total Cost": 1.01,
            "Plan Rows": 1,
            "Plan Width": 4,
            "Actual Startup Time": 0.004,
            "Actual Total Time": 0.004,
            "Actual Rows": 1,
            "Actual Loops": 1,
            "Output": ["u.oid"],
            "Hash Buckets": 1024,
            "Hash Batches": 1,
            "Original Hash Batches": 1,
            "Peak Memory Usage": 1,
            "Shared Hit Blocks": 1,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000,
            "Plans": [
              {
                "Node Type": "Seq Scan",
                "Parent Relationship": "Outer",
                "Relation Name": "pg_authid",
                "Schema": "pg_catalog",
                "Alias": "u",
                "Startup Cost": 0.00,
                "Total Cost": 1.01,
                "Plan Rows": 1,
                "Plan Width": 4,
                "Actual Startup Time": 0.003,
                "Actual Total Time": 0.003,
                "Actual Rows": 1,
                "Actual Loops": 1,
                "Output": ["u.oid"],
                "Shared Hit Blocks": 1,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "I/O Read Time": 0.000,
                "I/O Write Time": 0.000
              }
            ]
          }
        ]
      },
      {
        "Node Type": "Index Scan",
        "Parent Relationship": "Inner",
        "Scan Direction": "Forward",
        "Index Name": "pg_database_oid_index",
        "Relation Name": "pg_database",
        "Schema": "pg_catalog",
        "Alias": "d",
        "Startup Cost": 0.13,
        "Total Cost": 0.27,
        "Plan Rows": 1,
        "Plan Width": 68,
        "Actual Startup Time": 0.004,
        "Actual Total Time": 0.005,
        "Actual Rows": 1,
        "Actual Loops": 2,
        "Output": ["d.datname", "d.oid"],
        "Index Cond": "(d.oid = s.datid)",
        "Rows Removed by Index Recheck": 0,
        "Shared Hit Blocks": 4,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000
      }
    ]
  },
  "Planning Time": 0.356,
  "Triggers": [
  ],
  "Execution Time": 0.118
}'),
(10, '###### Plan 10: MergeAppend, Values',
 E'{
  "Plan": {
    "Node Type": "Merge Append",
    "Startup Cost": 0.36,
    "Total Cost": 985.44,
    "Plan Rows": 10004,
    "Plan Width": 4,
    "Actual Startup Time": 0.018,
    "Actual Total Time": 19.887,
    "Actual Rows": 10004,
    "Actual Loops": 1,
    "Sort Key": ["tt1.a"],
    "Shared Hit Blocks": 30069,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Index Only Scan",
        "Parent Relationship": "Member",
        "Scan Direction": "Forward",
        "Index Name": "i_tt1",
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.29,
        "Total Cost": 760.30,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 0.010,
        "Actual Total Time": 17.933,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["tt1.a"],
        "Heap Fetches": 29973,
        "Shared Hit Blocks": 30069,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000
      },
      {
        "Node Type": "Sort",
        "Parent Relationship": "Member",
        "Startup Cost": 0.06,
        "Total Cost": 0.07,
        "Plan Rows": 3,
        "Plan Width": 4,
        "Actual Startup Time": 0.007,
        "Actual Total Time": 0.008,
        "Actual Rows": 3,
        "Actual Loops": 1,
        "Output": ["\\"*VALUES*\\".column1"],
        "Sort Key": ["\\"*VALUES*\\".column1"],
        "Sort Method": "quicksort",
        "Sort Space Used": 25,
        "Sort Space Type": "Memory",
        "Shared Hit Blocks": 0,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Values Scan",
            "Parent Relationship": "Outer",
            "Alias": "*VALUES*",
            "Startup Cost": 0.00,
            "Total Cost": 0.04,
            "Plan Rows": 3,
            "Plan Width": 4,
            "Actual Startup Time": 0.001,
            "Actual Total Time": 0.002,
            "Actual Rows": 3,
            "Actual Loops": 1,
            "Output": ["\\"*VALUES*\\".column1"],
            "Shared Hit Blocks": 0,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000
          }
        ]
      }
    ]
  },
  "Planning Time": 0.087,
  "Triggers": [
  ],
  "Execution Time": 20.999
}'),
(11, '###### Plan 11: Append, HashAggregate',
 '{
  "Plan": {
    "Node Type": "Aggregate",
    "Strategy": "Hashed",
    "Startup Cost": 668.04,
    "Total Cost": 868.06,
    "Plan Rows": 20002,
    "Plan Width": 4,
    "Actual Startup Time": 14.097,
    "Actual Total Time": 18.092,
    "Actual Rows": 20002,
    "Actual Loops": 1,
    "Output": ["tt1.a"],
    "Group Key": ["tt1.a"],
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Append",
        "Parent Relationship": "Outer",
        "Startup Cost": 0.00,
        "Total Cost": 618.04,
        "Plan Rows": 20002,
        "Plan Width": 4,
        "Actual Startup Time": 0.093,
        "Actual Total Time": 7.382,
        "Actual Rows": 20002,
        "Actual Loops": 1,
        "Shared Hit Blocks": 218,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Member",
            "Relation Name": "tt1",
            "Schema": "public",
            "Alias": "tt1",
            "Startup Cost": 0.00,
            "Total Cost": 263.01,
            "Plan Rows": 10001,
            "Plan Width": 4,
            "Actual Startup Time": 0.092,
            "Actual Total Time": 2.370,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["tt1.a"],
            "Shared Hit Blocks": 163,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000
          },
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Member",
            "Relation Name": "tt2",
            "Schema": "public",
            "Alias": "tt2",
            "Startup Cost": 0.00,
            "Total Cost": 155.01,
            "Plan Rows": 10001,
            "Plan Width": 4,
            "Actual Startup Time": 0.006,
            "Actual Total Time": 2.367,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["tt2.b"],
            "Shared Hit Blocks": 55,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000
          }
        ]
      }
    ]
  },
  "Planning Time": 0.055,
  "Triggers": [
  ],
  "Execution Time": 20.063
}'),
(12, '###### Plan 12: GroupAggregate',
 '{
  "Plan": {
    "Node Type": "Aggregate",
    "Strategy": "Sorted",
    "Startup Cost": 1067.47,
    "Total Cost": 1242.49,
    "Plan Rows": 10001,
    "Plan Width": 8,
    "Actual Startup Time": 10.889,
    "Actual Total Time": 20.301,
    "Actual Rows": 10001,
    "Actual Loops": 1,
    "Output": ["sum(a)", "b"],
    "Group Key": ["tt1.b"],
    "Shared Hit Blocks": 163,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 33,
    "Temp Written Blocks": 33,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Sort",
        "Parent Relationship": "Outer",
        "Startup Cost": 1067.47,
        "Total Cost": 1092.47,
        "Plan Rows": 10001,
        "Plan Width": 8,
        "Actual Startup Time": 10.886,
        "Actual Total Time": 14.220,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["b", "a"],
        "Sort Key": ["tt1.b"],
        "Sort Method": "external merge",
        "Sort Space Used": 168,
        "Sort Space Type": "Disk",
        "Shared Hit Blocks": 163,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 33,
        "Temp Written Blocks": 33,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Outer",
            "Relation Name": "tt1",
            "Schema": "public",
            "Alias": "tt1",
            "Startup Cost": 0.00,
            "Total Cost": 263.01,
            "Plan Rows": 10001,
            "Plan Width": 8,
            "Actual Startup Time": 0.114,
            "Actual Total Time": 2.441,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["b", "a"],
            "Shared Hit Blocks": 163,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000
          }
        ]
      }
    ]
  },
  "Planning Time": 0.041,
  "Triggers": [
  ],
  "Execution Time": 21.797
}'),
(13, '###### Plan 13: Group',
 '{
  "Plan": {
    "Node Type": "Group",
    "Startup Cost": 1067.47,
    "Total Cost": 1117.47,
    "Plan Rows": 10001,
    "Plan Width": 4,
    "Actual Startup Time": 10.358,
    "Actual Total Time": 17.790,
    "Actual Rows": 10001,
    "Actual Loops": 1,
    "Output": ["b"],
    "Group Key": ["tt1.b"],
    "Shared Hit Blocks": 163,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 25,
    "Temp Written Blocks": 25,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Sort",
        "Parent Relationship": "Outer",
        "Startup Cost": 1067.47,
        "Total Cost": 1092.47,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 10.356,
        "Actual Total Time": 13.699,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["b"],
        "Sort Key": ["tt1.b"],
        "Sort Method": "external merge",
        "Sort Space Used": 120,
        "Sort Space Type": "Disk",
        "Shared Hit Blocks": 163,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 25,
        "Temp Written Blocks": 25,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Outer",
            "Relation Name": "tt1",
            "Schema": "public",
            "Alias": "tt1",
            "Startup Cost": 0.00,
            "Total Cost": 263.01,
            "Plan Rows": 10001,
            "Plan Width": 4,
            "Actual Startup Time": 0.092,
            "Actual Total Time": 2.298,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["b"],
            "Shared Hit Blocks": 163,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000
          }
        ]
      }
    ]
  },
  "Planning Time": 0.032,
  "Triggers": [
  ],
  "Execution Time": 18.628
}'),
(14, '###### Plan 14: SetOp intersect, SbuqueryScan',
 E'{
  "Plan": {
    "Node Type": "Sort",
    "Startup Cost": 1332.50,
    "Total Cost": 1357.51,
    "Plan Rows": 10001,
    "Plan Width": 4,
    "Actual Startup Time": 17.468,
    "Actual Total Time": 17.468,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Output": ["\\"*SELECT* 1\\".a", "(0)"],
    "Sort Key": ["\\"*SELECT* 1\\".a"],
    "Sort Method": "quicksort",
    "Sort Space Used": 25,
    "Sort Space Type": "Memory",
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "SetOp",
        "Strategy": "Hashed",
        "Parent Relationship": "Outer",
        "Command": "Intersect",
        "Startup Cost": 0.00,
        "Total Cost": 668.04,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 17.465,
        "Actual Total Time": 17.465,
        "Actual Rows": 0,
        "Actual Loops": 1,
        "Output": ["\\"*SELECT* 1\\".a", "(0)"],
        "Shared Hit Blocks": 218,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Append",
            "Parent Relationship": "Outer",
            "Startup Cost": 0.00,
            "Total Cost": 618.04,
            "Plan Rows": 20002,
            "Plan Width": 4,
            "Actual Startup Time": 0.095,
            "Actual Total Time": 11.726,
            "Actual Rows": 20002,
            "Actual Loops": 1,
            "Shared Hit Blocks": 218,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000,
            "Plans": [
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Alias": "*SELECT* 1",
                "Startup Cost": 0.00,
                "Total Cost": 363.02,
                "Plan Rows": 10001,
                "Plan Width": 4,
                "Actual Startup Time": 0.095,
                "Actual Total Time": 4.614,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 1\\".a", "0"],
                "Shared Hit Blocks": 163,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "I/O Read Time": 0.000,
                "I/O Write Time": 0.000,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Relation Name": "tt1",
                    "Schema": "public",
                    "Alias": "tt1",
                    "Startup Cost": 0.00,
                    "Total Cost": 263.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.094,
                    "Actual Total Time": 2.368,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt1.a"],
                    "Shared Hit Blocks": 163,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0,
                    "I/O Read Time": 0.000,
                    "I/O Write Time": 0.000
                  }
                ]
              },
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Alias": "*SELECT* 2",
                "Startup Cost": 0.00,
                "Total Cost": 255.02,
                "Plan Rows": 10001,
                "Plan Width": 4,
                "Actual Startup Time": 0.007,
                "Actual Total Time": 4.576,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 2\\".b", "1"],
                "Shared Hit Blocks": 55,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "I/O Read Time": 0.000,
                "I/O Write Time": 0.000,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Relation Name": "tt2",
                    "Schema": "public",
                    "Alias": "tt2",
                    "Startup Cost": 0.00,
                    "Total Cost": 155.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.006,
                    "Actual Total Time": 2.340,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt2.b"],
                    "Shared Hit Blocks": 55,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0,
                    "I/O Read Time": 0.000,
                    "I/O Write Time": 0.000
                  }
                ]
              }
            ]
          }
        ]
      }
    ]
  },
  "Planning Time": 0.061,
  "Triggers": [
  ],
  "Execution Time": 17.700
}'),
(15, '###### Plan 15: Sorted SetOp, Sort on Disk',
 E'{
  "Plan": {
    "Node Type": "SetOp",
    "Strategy": "Sorted",
    "Command": "Intersect",
    "Startup Cost": 2323.47,
    "Total Cost": 2423.48,
    "Plan Rows": 10001,
    "Plan Width": 4,
    "Actual Startup Time": 44.652,
    "Actual Total Time": 44.652,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Output": ["\\"*SELECT* 1\\".a", "(0)"],
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 77,
    "Temp Written Blocks": 77,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Sort",
        "Parent Relationship": "Outer",
        "Startup Cost": 2323.47,
        "Total Cost": 2373.47,
        "Plan Rows": 20002,
        "Plan Width": 4,
        "Actual Startup Time": 32.559,
        "Actual Total Time": 38.440,
        "Actual Rows": 20002,
        "Actual Loops": 1,
        "Output": ["\\"*SELECT* 1\\".a", "(0)"],
        "Sort Key": ["\\"*SELECT* 1\\".a"],
        "Sort Method": "external merge",
        "Sort Space Used": 352,
        "Sort Space Type": "Disk",
        "Shared Hit Blocks": 218,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 77,
        "Temp Written Blocks": 77,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Append",
            "Parent Relationship": "Outer",
            "Startup Cost": 0.00,
            "Total Cost": 618.04,
            "Plan Rows": 20002,
            "Plan Width": 4,
            "Actual Startup Time": 0.095,
            "Actual Total Time": 12.510,
            "Actual Rows": 20002,
            "Actual Loops": 1,
            "Shared Hit Blocks": 218,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000,
            "Plans": [
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Alias": "*SELECT* 1",
                "Startup Cost": 0.00,
                "Total Cost": 363.02,
                "Plan Rows": 10001,
                "Plan Width": 4,
                "Actual Startup Time": 0.095,
                "Actual Total Time": 5.112,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 1\\".a", "0"],
                "Shared Hit Blocks": 163,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "I/O Read Time": 0.000,
                "I/O Write Time": 0.000,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Relation Name": "tt1",
                    "Schema": "public",
                    "Alias": "tt1",
                    "Startup Cost": 0.00,
                    "Total Cost": 263.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.095,
                    "Actual Total Time": 2.550,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt1.a"],
                    "Shared Hit Blocks": 163,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0,
                    "I/O Read Time": 0.000,
                    "I/O Write Time": 0.000
                  }
                ]
              },
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Alias": "*SELECT* 2",
                "Startup Cost": 0.00,
                "Total Cost": 255.02,
                "Plan Rows": 10001,
                "Plan Width": 4,
                "Actual Startup Time": 0.006,
                "Actual Total Time": 4.729,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 2\\".b", "1"],
                "Shared Hit Blocks": 55,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "I/O Read Time": 0.000,
                "I/O Write Time": 0.000,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Relation Name": "tt2",
                    "Schema": "public",
                    "Alias": "tt2",
                    "Startup Cost": 0.00,
                    "Total Cost": 155.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.006,
                    "Actual Total Time": 2.414,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt2.b"],
                    "Shared Hit Blocks": 55,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0,
                    "I/O Read Time": 0.000,
                    "I/O Write Time": 0.000
                  }
                ]
              }
            ]
          }
        ]
      }
    ]
  },
  "Planning Time": 0.062,
  "Triggers": [
  ],
  "Execution Time": 44.785
}'),
(16, '###### Plan 16: HashSetOp intersect All, SubqueryScan',
 E'{
  "Plan": {
    "Node Type": "Sort",
    "Startup Cost": 1332.50,
    "Total Cost": 1357.51,
    "Plan Rows": 10001,
    "Plan Width": 4,
    "Actual Startup Time": 18.390,
    "Actual Total Time": 18.390,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Output": ["\\"*SELECT* 1\\".a", "(0)"],
    "Sort Key": ["\\"*SELECT* 1\\".a"],
    "Sort Method": "quicksort",
    "Sort Space Used": 25,
    "Sort Space Type": "Memory",
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "SetOp",
        "Strategy": "Hashed",
        "Parent Relationship": "Outer",
        "Command": "Intersect All",
        "Startup Cost": 0.00,
        "Total Cost": 668.04,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 18.387,
        "Actual Total Time": 18.387,
        "Actual Rows": 0,
        "Actual Loops": 1,
        "Output": ["\\"*SELECT* 1\\".a", "(0)"],
        "Shared Hit Blocks": 218,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Append",
            "Parent Relationship": "Outer",
            "Startup Cost": 0.00,
            "Total Cost": 618.04,
            "Plan Rows": 20002,
            "Plan Width": 4,
            "Actual Startup Time": 0.096,
            "Actual Total Time": 12.322,
            "Actual Rows": 20002,
            "Actual Loops": 1,
            "Shared Hit Blocks": 218,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000,
            "Plans": [
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Alias": "*SELECT* 1",
                "Startup Cost": 0.00,
                "Total Cost": 363.02,
                "Plan Rows": 10001,
                "Plan Width": 4,
                "Actual Startup Time": 0.095,
                "Actual Total Time": 4.829,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 1\\".a", "0"],
                "Shared Hit Blocks": 163,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "I/O Read Time": 0.000,
                "I/O Write Time": 0.000,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Relation Name": "tt1",
                    "Schema": "public",
                    "Alias": "tt1",
                    "Startup Cost": 0.00,
                    "Total Cost": 263.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.095,
                    "Actual Total Time": 2.460,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt1.a"],
                    "Shared Hit Blocks": 163,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0,
                    "I/O Read Time": 0.000,
                    "I/O Write Time": 0.000
                  }
                ]
              },
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Alias": "*SELECT* 2",
                "Startup Cost": 0.00,
                "Total Cost": 255.02,
                "Plan Rows": 10001,
                "Plan Width": 4,
                "Actual Startup Time": 0.007,
                "Actual Total Time": 4.660,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 2\\".b", "1"],
                "Shared Hit Blocks": 55,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "I/O Read Time": 0.000,
                "I/O Write Time": 0.000,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Relation Name": "tt2",
                    "Schema": "public",
                    "Alias": "tt2",
                    "Startup Cost": 0.00,
                    "Total Cost": 155.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.007,
                    "Actual Total Time": 2.402,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt2.b"],
                    "Shared Hit Blocks": 55,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0,
                    "I/O Read Time": 0.000,
                    "I/O Write Time": 0.000
                  }
                ]
              }
            ]
          }
        ]
      }
    ]
  },
  "Planning Time": 0.061,
  "Triggers": [
  ],
  "Execution Time": 18.626
}'),
(17, '###### Plan 17: HashSetOp except, SubqueryScan',
 E'{
  "Plan": {
    "Node Type": "Sort",
    "Startup Cost": 1332.50,
    "Total Cost": 1357.51,
    "Plan Rows": 10001,
    "Plan Width": 4,
    "Actual Startup Time": 24.448,
    "Actual Total Time": 25.233,
    "Actual Rows": 10001,
    "Actual Loops": 1,
    "Output": ["\\"*SELECT* 1\\".a", "(0)"],
    "Sort Key": ["\\"*SELECT* 1\\".a"],
    "Sort Method": "quicksort",
    "Sort Space Used": 855,
    "Sort Space Type": "Memory",
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "SetOp",
        "Strategy": "Hashed",
        "Parent Relationship": "Outer",
        "Command": "Except",
        "Startup Cost": 0.00,
        "Total Cost": 668.04,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 18.989,
        "Actual Total Time": 20.104,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["\\"*SELECT* 1\\".a", "(0)"],
        "Shared Hit Blocks": 218,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Append",
            "Parent Relationship": "Outer",
            "Startup Cost": 0.00,
            "Total Cost": 618.04,
            "Plan Rows": 20002,
            "Plan Width": 4,
            "Actual Startup Time": 0.095,
            "Actual Total Time": 12.996,
            "Actual Rows": 20002,
            "Actual Loops": 1,
            "Shared Hit Blocks": 218,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000,
            "Plans": [
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Alias": "*SELECT* 1",
                "Startup Cost": 0.00,
                "Total Cost": 363.02,
                "Plan Rows": 10001,
                "Plan Width": 4,
                "Actual Startup Time": 0.094,
                "Actual Total Time": 5.579,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 1\\".a", "0"],
                "Shared Hit Blocks": 163,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "I/O Read Time": 0.000,
                "I/O Write Time": 0.000,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Relation Name": "tt1",
                    "Schema": "public",
                    "Alias": "tt1",
                    "Startup Cost": 0.00,
                    "Total Cost": 263.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.093,
                    "Actual Total Time": 2.839,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt1.a"],
                    "Shared Hit Blocks": 163,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0,
                    "I/O Read Time": 0.000,
                    "I/O Write Time": 0.000
                  }
                ]
              },
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Alias": "*SELECT* 2",
                "Startup Cost": 0.00,
                "Total Cost": 255.02,
                "Plan Rows": 10001,
                "Plan Width": 4,
                "Actual Startup Time": 0.007,
                "Actual Total Time": 4.559,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 2\\".b", "1"],
                "Shared Hit Blocks": 55,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "I/O Read Time": 0.000,
                "I/O Write Time": 0.000,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Relation Name": "tt2",
                    "Schema": "public",
                    "Alias": "tt2",
                    "Startup Cost": 0.00,
                    "Total Cost": 155.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.006,
                    "Actual Total Time": 2.353,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt2.b"],
                    "Shared Hit Blocks": 55,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0,
                    "I/O Read Time": 0.000,
                    "I/O Write Time": 0.000
                  }
                ]
              }
            ]
          }
        ]
      }
    ]
  },
  "Planning Time": 0.060,
  "Triggers": [
  ],
  "Execution Time": 27.190
}'),
(18, '###### Plan 18: HashSetOp except all, SubqueryScan',
 E'{
  "Plan": {
    "Node Type": "Sort",
    "Startup Cost": 1332.50,
    "Total Cost": 1357.51,
    "Plan Rows": 10001,
    "Plan Width": 4,
    "Actual Startup Time": 24.246,
    "Actual Total Time": 25.047,
    "Actual Rows": 10001,
    "Actual Loops": 1,
    "Output": ["\\"*SELECT* 1\\".a", "(0)"],
    "Sort Key": ["\\"*SELECT* 1\\".a"],
    "Sort Method": "quicksort",
    "Sort Space Used": 855,
    "Sort Space Type": "Memory",
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "SetOp",
        "Strategy": "Hashed",
        "Parent Relationship": "Outer",
        "Command": "Except All",
        "Startup Cost": 0.00,
        "Total Cost": 668.04,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 18.981,
        "Actual Total Time": 20.120,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["\\"*SELECT* 1\\".a", "(0)"],
        "Shared Hit Blocks": 218,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Append",
            "Parent Relationship": "Outer",
            "Startup Cost": 0.00,
            "Total Cost": 618.04,
            "Plan Rows": 20002,
            "Plan Width": 4,
            "Actual Startup Time": 0.117,
            "Actual Total Time": 12.994,
            "Actual Rows": 20002,
            "Actual Loops": 1,
            "Shared Hit Blocks": 218,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000,
            "Plans": [
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Alias": "*SELECT* 1",
                "Startup Cost": 0.00,
                "Total Cost": 363.02,
                "Plan Rows": 10001,
                "Plan Width": 4,
                "Actual Startup Time": 0.117,
                "Actual Total Time": 5.606,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 1\\".a", "0"],
                "Shared Hit Blocks": 163,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "I/O Read Time": 0.000,
                "I/O Write Time": 0.000,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Relation Name": "tt1",
                    "Schema": "public",
                    "Alias": "tt1",
                    "Startup Cost": 0.00,
                    "Total Cost": 263.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.116,
                    "Actual Total Time": 2.894,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt1.a"],
                    "Shared Hit Blocks": 163,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0,
                    "I/O Read Time": 0.000,
                    "I/O Write Time": 0.000
                  }
                ]
              },
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Alias": "*SELECT* 2",
                "Startup Cost": 0.00,
                "Total Cost": 255.02,
                "Plan Rows": 10001,
                "Plan Width": 4,
                "Actual Startup Time": 0.007,
                "Actual Total Time": 4.520,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 2\\".b", "1"],
                "Shared Hit Blocks": 55,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "I/O Read Time": 0.000,
                "I/O Write Time": 0.000,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Relation Name": "tt2",
                    "Schema": "public",
                    "Alias": "tt2",
                    "Startup Cost": 0.00,
                    "Total Cost": 155.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.006,
                    "Actual Total Time": 2.336,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt2.b"],
                    "Shared Hit Blocks": 55,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0,
                    "I/O Read Time": 0.000,
                    "I/O Write Time": 0.000
                  }
                ]
              }
            ]
          }
        ]
      }
    ]
  },
  "Planning Time": 0.079,
  "Triggers": [
  ],
  "Execution Time": 26.975
}'),
(19, '###### Plan 19: merge LEFT join',
 '{
  "Plan": {
    "Node Type": "Merge Join",
    "Join Type": "Left",
    "Startup Cost": 0.71,
    "Total Cost": 4245.45,
    "Plan Rows": 33453,
    "Plan Width": 4,
    "Actual Startup Time": 0.034,
    "Actual Total Time": 56.948,
    "Actual Rows": 60003,
    "Actual Loops": 1,
    "Output": ["x.b"],
    "Merge Cond": "(x.a = y.a)",
    "Shared Hit Blocks": 20930,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Index Scan",
        "Parent Relationship": "Outer",
        "Scan Direction": "Forward",
        "Index Name": "i_tt1",
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "x",
        "Startup Cost": 0.29,
        "Total Cost": 760.30,
        "Plan Rows": 10001,
        "Plan Width": 8,
        "Actual Startup Time": 0.008,
        "Actual Total Time": 4.032,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["x.a", "x.b", "x.c"],
        "Shared Hit Blocks": 165,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000
      },
      {
        "Node Type": "Index Only Scan",
        "Parent Relationship": "Inner",
        "Scan Direction": "Forward",
        "Index Name": "i_tt3_a",
        "Relation Name": "tt3",
        "Schema": "public",
        "Alias": "y",
        "Startup Cost": 0.42,
        "Total Cost": 9034.11,
        "Plan Rows": 180003,
        "Plan Width": 4,
        "Actual Startup Time": 0.022,
        "Actual Total Time": 29.832,
        "Actual Rows": 60004,
        "Actual Loops": 1,
        "Output": ["y.a"],
        "Heap Fetches": 60004,
        "Shared Hit Blocks": 20765,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000
      }
    ]
  },
  "Planning Time": 0.390,
  "Triggers": [
  ],
  "Execution Time": 62.450
}'),
(20, '###### Plan 20: hash FULL join',
 '{
  "Plan": {
    "Node Type": "Hash Join",
    "Join Type": "Full",
    "Startup Cost": 280.02,
    "Total Cost": 793.06,
    "Plan Rows": 10001,
    "Plan Width": 4,
    "Actual Startup Time": 11.957,
    "Actual Total Time": 21.814,
    "Actual Rows": 17001,
    "Actual Loops": 1,
    "Output": ["x.b"],
    "Hash Cond": "(x.a = y.a)",
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Outer",
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "x",
        "Startup Cost": 0.00,
        "Total Cost": 263.01,
        "Plan Rows": 10001,
        "Plan Width": 8,
        "Actual Startup Time": 0.205,
        "Actual Total Time": 2.212,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["x.a", "x.b", "x.c"],
        "Shared Hit Blocks": 163,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000
      },
      {
        "Node Type": "Hash",
        "Parent Relationship": "Inner",
        "Startup Cost": 155.01,
        "Total Cost": 155.01,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 11.741,
        "Actual Total Time": 11.741,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["y.a"],
        "Hash Buckets": 1024,
        "Hash Batches": 1,
        "Original Hash Batches": 1,
        "Peak Memory Usage": 352,
        "Shared Hit Blocks": 55,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Outer",
            "Relation Name": "tt2",
            "Schema": "public",
            "Alias": "y",
            "Startup Cost": 0.00,
            "Total Cost": 155.01,
            "Plan Rows": 10001,
            "Plan Width": 4,
            "Actual Startup Time": 0.018,
            "Actual Total Time": 5.489,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["y.a"],
            "Shared Hit Blocks": 55,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000
          }
        ]
      }
    ]
  },
  "Planning Time": 0.194,
  "Triggers": [
  ],
  "Execution Time": 23.606
}'),
(21, '###### Plan 21: hash SEMI join',
 '{
  "Plan": {
    "Node Type": "Hash Join",
    "Join Type": "Semi",
    "Startup Cost": 280.02,
    "Total Cost": 793.06,
    "Plan Rows": 10001,
    "Plan Width": 12,
    "Actual Startup Time": 10.770,
    "Actual Total Time": 10.770,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Output": ["tt1.a", "tt1.b", "tt1.c"],
    "Hash Cond": "(tt1.a = tt2.b)",
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Outer",
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.00,
        "Total Cost": 263.01,
        "Plan Rows": 10001,
        "Plan Width": 12,
        "Actual Startup Time": 0.091,
        "Actual Total Time": 1.495,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["tt1.a", "tt1.b", "tt1.c"],
        "Shared Hit Blocks": 163,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000
      },
      {
        "Node Type": "Hash",
        "Parent Relationship": "Inner",
        "Startup Cost": 155.01,
        "Total Cost": 155.01,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 5.798,
        "Actual Total Time": 5.798,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["tt2.b"],
        "Hash Buckets": 1024,
        "Hash Batches": 1,
        "Original Hash Batches": 1,
        "Peak Memory Usage": 352,
        "Shared Hit Blocks": 55,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Outer",
            "Relation Name": "tt2",
            "Schema": "public",
            "Alias": "tt2",
            "Startup Cost": 0.00,
            "Total Cost": 155.01,
            "Plan Rows": 10001,
            "Plan Width": 4,
            "Actual Startup Time": 0.007,
            "Actual Total Time": 2.812,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["tt2.b"],
            "Shared Hit Blocks": 55,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000
          }
        ]
      }
    ]
  },
  "Planning Time": 0.182,
  "Triggers": [
  ],
  "Execution Time": 10.988
}'),
(22, '###### Plan 22: Hash Anti Join',
 '{
  "Plan": {
    "Node Type": "Hash Join",
    "Join Type": "Anti",
    "Startup Cost": 280.02,
    "Total Cost": 693.05,
    "Plan Rows": 1,
    "Plan Width": 12,
    "Actual Startup Time": 5.985,
    "Actual Total Time": 12.403,
    "Actual Rows": 10001,
    "Actual Loops": 1,
    "Output": ["tt1.a", "tt1.b", "tt1.c"],
    "Hash Cond": "(tt1.a = tt2.b)",
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Outer",
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.00,
        "Total Cost": 263.01,
        "Plan Rows": 10001,
        "Plan Width": 12,
        "Actual Startup Time": 0.095,
        "Actual Total Time": 1.543,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["tt1.a", "tt1.b", "tt1.c"],
        "Shared Hit Blocks": 163,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000
      },
      {
        "Node Type": "Hash",
        "Parent Relationship": "Inner",
        "Startup Cost": 155.01,
        "Total Cost": 155.01,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 5.884,
        "Actual Total Time": 5.884,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["tt2.b"],
        "Hash Buckets": 1024,
        "Hash Batches": 1,
        "Original Hash Batches": 1,
        "Peak Memory Usage": 352,
        "Shared Hit Blocks": 55,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Outer",
            "Relation Name": "tt2",
            "Schema": "public",
            "Alias": "tt2",
            "Startup Cost": 0.00,
            "Total Cost": 155.01,
            "Plan Rows": 10001,
            "Plan Width": 4,
            "Actual Startup Time": 0.007,
            "Actual Total Time": 2.808,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["tt2.b"],
            "Shared Hit Blocks": 55,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000
          }
        ]
      }
    ]
  },
  "Planning Time": 0.133,
  "Triggers": [
  ],
  "Execution Time": 13.415
}'),
(23, '###### Plan 23: WindowAgg',
 '{
  "Plan": {
    "Node Type": "WindowAgg",
    "Startup Cost": 927.47,
    "Total Cost": 1127.49,
    "Plan Rows": 10001,
    "Plan Width": 4,
    "Actual Startup Time": 5.593,
    "Actual Total Time": 16.541,
    "Actual Rows": 10001,
    "Actual Loops": 1,
    "Output": ["first_value(a) OVER (?)", "((a / 10))"],
    "Shared Hit Blocks": 163,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Sort",
        "Parent Relationship": "Outer",
        "Startup Cost": 927.47,
        "Total Cost": 952.47,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 5.585,
        "Actual Total Time": 6.517,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["((a / 10))", "a"],
        "Sort Key": ["((tt1.a / 10))"],
        "Sort Method": "quicksort",
        "Sort Space Used": 855,
        "Sort Space Type": "Memory",
        "Shared Hit Blocks": 163,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Outer",
            "Relation Name": "tt1",
            "Schema": "public",
            "Alias": "tt1",
            "Startup Cost": 0.00,
            "Total Cost": 263.01,
            "Plan Rows": 10001,
            "Plan Width": 4,
            "Actual Startup Time": 0.096,
            "Actual Total Time": 2.997,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["(a / 10)", "a"],
            "Shared Hit Blocks": 163,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000
          }
        ]
      }
    ]
  },
  "Planning Time": 0.051,
  "Triggers": [
  ],
  "Execution Time": 17.892
}'),
(24, '###### Plan 24: Unique',
 '{
  "Plan": {
    "Node Type": "Unique",
    "Startup Cost": 0.29,
    "Total Cost": 785.30,
    "Plan Rows": 10001,
    "Plan Width": 4,
    "Actual Startup Time": 0.010,
    "Actual Total Time": 7.878,
    "Actual Rows": 10001,
    "Actual Loops": 1,
    "Output": ["a"],
    "Shared Hit Blocks": 165,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Index Only Scan",
        "Parent Relationship": "Outer",
        "Scan Direction": "Forward",
        "Index Name": "i_tt1",
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.29,
        "Total Cost": 760.30,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 0.010,
        "Actual Total Time": 4.020,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["a"],
        "Heap Fetches": 10001,
        "Shared Hit Blocks": 165,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000
      }
    ]
  },
  "Planning Time": 0.044,
  "Triggers": [
  ],
  "Execution Time": 8.769
}'),
(25, '###### Plan 25: PlainAggregate',
 '{
  "Plan": {
    "Node Type": "Aggregate",
    "Strategy": "Plain",
    "Startup Cost": 288.01,
    "Total Cost": 288.02,
    "Plan Rows": 1,
    "Plan Width": 4,
    "Actual Startup Time": 3.283,
    "Actual Total Time": 3.283,
    "Actual Rows": 1,
    "Actual Loops": 1,
    "Output": ["sum(a)"],
    "Shared Hit Blocks": 163,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Outer",
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.00,
        "Total Cost": 263.01,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 0.095,
        "Actual Total Time": 1.442,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["a", "b", "c"],
        "Shared Hit Blocks": 163,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000
      }
    ]
  },
  "Planning Time": 0.031,
  "Triggers": [
  ],
  "Execution Time": 3.307
}'),
(26, '###### Plan 26: BitmapIndexScan/BitmapHeapScan, BitmapOr, lossy',
 '{
  "Plan": {
    "Node Type": "Bitmap Heap Scan",
    "Relation Name": "tt3",
    "Schema": "public",
    "Alias": "tt3",
    "Startup Cost": 4243.43,
    "Total Cost": 7466.44,
    "Plan Rows": 180001,
    "Plan Width": 12,
    "Actual Startup Time": 26.161,
    "Actual Total Time": 65.167,
    "Actual Rows": 180000,
    "Actual Loops": 1,
    "Output": ["a", "b", "c"],
    "Recheck Cond": "(tt3.b > (-99998))",
    "Rows Removed by Index Recheck": 3,
    "Exact Heap Blocks": 558,
    "Lossy Heap Blocks": 415,
    "Shared Hit Blocks": 1683,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Bitmap Index Scan",
        "Parent Relationship": "Outer",
        "Index Name": "i_tt3_b",
        "Startup Cost": 0.00,
        "Total Cost": 4198.43,
        "Plan Rows": 180001,
        "Plan Width": 0,
        "Actual Startup Time": 26.049,
        "Actual Total Time": 26.049,
        "Actual Rows": 180000,
        "Actual Loops": 1,
        "Index Cond": "(tt3.b > (-99998))",
        "Shared Hit Blocks": 710,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000
      }
    ]
  },
  "Planning Time": 0.102,
  "Triggers": [
  ],
  "Execution Time": 79.090
}'),
(27, '###### Plan 27: Join Filter',
 '{
  "Plan": {
    "Node Type": "Limit",
    "Startup Cost": 0.00,
    "Total Cost": 21.52,
    "Plan Rows": 100,
    "Plan Width": 12,
    "Actual Startup Time": 5.323,
    "Actual Total Time": 5.448,
    "Actual Rows": 100,
    "Actual Loops": 1,
    "Output": ["tt2.a", "tt2.b", "tt2.c"],
    "Shared Hit Blocks": 40,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 12,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Nested Loop",
        "Parent Relationship": "Outer",
        "Join Type": "Inner",
        "Startup Cost": 0.00,
        "Total Cost": 43048282.11,
        "Plan Rows": 200023334,
        "Plan Width": 12,
        "Actual Startup Time": 5.323,
        "Actual Total Time": 5.435,
        "Actual Rows": 100,
        "Actual Loops": 1,
        "Output": ["tt2.a", "tt2.b", "tt2.c"],
        "Join Filter": "((tt2.a < tt3.a) AND ((tt3.a + tt2.a) < 100000))",
        "Rows Removed by Join Filter": 7001,
        "Shared Hit Blocks": 40,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 12,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Outer",
            "Relation Name": "tt2",
            "Schema": "public",
            "Alias": "tt2",
            "Startup Cost": 0.00,
            "Total Cost": 155.01,
            "Plan Rows": 10001,
            "Plan Width": 12,
            "Actual Startup Time": 0.009,
            "Actual Total Time": 0.009,
            "Actual Rows": 1,
            "Actual Loops": 1,
            "Output": ["tt2.a", "tt2.b", "tt2.c"],
            "Shared Hit Blocks": 1,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000
          },
          {
            "Node Type": "Materialize",
            "Parent Relationship": "Inner",
            "Startup Cost": 0.00,
            "Total Cost": 4377.05,
            "Plan Rows": 180003,
            "Plan Width": 4,
            "Actual Startup Time": 0.009,
            "Actual Total Time": 4.223,
            "Actual Rows": 7101,
            "Actual Loops": 1,
            "Output": ["tt3.a"],
            "Shared Hit Blocks": 39,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 12,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000,
            "Plans": [
              {
                "Node Type": "Seq Scan",
                "Parent Relationship": "Outer",
                "Relation Name": "tt3",
                "Schema": "public",
                "Alias": "tt3",
                "Startup Cost": 0.00,
                "Total Cost": 2773.03,
                "Plan Rows": 180003,
                "Plan Width": 4,
                "Actual Startup Time": 0.007,
                "Actual Total Time": 1.608,
                "Actual Rows": 7101,
                "Actual Loops": 1,
                "Output": ["tt3.a"],
                "Shared Hit Blocks": 39,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "I/O Read Time": 0.000,
                "I/O Write Time": 0.000
              }
            ]
          }
        ]
      }
    ]
  },
  "Planning Time": 0.165,
  "Triggers": [
  ],
  "Execution Time": 5.553
}'),
(28, '###### Plan 28: TidScan',
 E'{
  "Plan": {
    "Node Type": "Tid Scan",
    "Relation Name": "tt3",
    "Schema": "public",
    "Alias": "tt3",
    "Startup Cost": 0.00,
    "Total Cost": 4.01,
    "Plan Rows": 1,
    "Plan Width": 12,
    "Actual Startup Time": 0.004,
    "Actual Total Time": 0.004,
    "Actual Rows": 1,
    "Actual Loops": 1,
    "Output": ["a", "b", "c"],
    "TID Cond": "(tt3.ctid = \'(0,28)\'::tid)",
    "Shared Hit Blocks": 1,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000
  },
  "Planning Time": 0.068,
  "Triggers": [
  ],
  "Execution Time": 0.017
}'),
(29, '###### Plan 29: LockRows',
 '{
  "Plan": {
    "Node Type": "LockRows",
    "Startup Cost": 0.00,
    "Total Cost": 313.51,
    "Plan Rows": 50,
    "Plan Width": 10,
    "Actual Startup Time": 0.146,
    "Actual Total Time": 5.055,
    "Actual Rows": 1001,
    "Actual Loops": 1,
    "Output": ["a", "ctid"],
    "Shared Hit Blocks": 1164,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Outer",
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.00,
        "Total Cost": 313.01,
        "Plan Rows": 50,
        "Plan Width": 10,
        "Actual Startup Time": 0.134,
        "Actual Total Time": 3.621,
        "Actual Rows": 1001,
        "Actual Loops": 1,
        "Output": ["a", "ctid"],
        "Filter": "((tt1.a % 10) = 0)",
        "Rows Removed by Filter": 9000,
        "Shared Hit Blocks": 163,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000
      }
    ]
  },
  "Planning Time": 0.041,
  "Triggers": [
  ],
  "Execution Time": 5.217
}'),
(30, '###### Plan 30: Materialize',
 '{
  "Plan": {
    "Node Type": "Seq Scan",
    "Relation Name": "tt1",
    "Schema": "public",
    "Alias": "tt1",
    "Startup Cost": 0.00,
    "Total Cost": 1150490.52,
    "Plan Rows": 5000,
    "Plan Width": 12,
    "Actual Startup Time": 5.929,
    "Actual Total Time": 5.929,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Output": ["tt1.a", "tt1.b", "tt1.c"],
    "Filter": "(SubPlan 1)",
    "Rows Removed by Filter": 10001,
    "Shared Hit Blocks": 164,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "I/O Read Time": 0.000,
    "I/O Write Time": 0.000,
    "Plans": [
      {
        "Node Type": "Materialize",
        "Parent Relationship": "SubPlan",
        "Subplan Name": "SubPlan 1",
        "Startup Cost": 0.00,
        "Total Cost": 205.01,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 0.000,
        "Actual Total Time": 0.000,
        "Actual Rows": 1,
        "Actual Loops": 10001,
        "Output": ["tt2.b"],
        "Shared Hit Blocks": 1,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "I/O Read Time": 0.000,
        "I/O Write Time": 0.000,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Outer",
            "Relation Name": "tt2",
            "Schema": "public",
            "Alias": "tt2",
            "Startup Cost": 0.00,
            "Total Cost": 155.01,
            "Plan Rows": 10001,
            "Plan Width": 4,
            "Actual Startup Time": 0.008,
            "Actual Total Time": 0.008,
            "Actual Rows": 1,
            "Actual Loops": 1,
            "Output": ["tt2.b"],
            "Shared Hit Blocks": 1,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "I/O Read Time": 0.000,
            "I/O Write Time": 0.000
          }
        ]
      }
    ]
  },
  "Planning Time": 0.102,
  "Triggers": [
  ],
  "Execution Time": 5.957
}'));

\pset pager
\set ECHO queries

\echo ###### set shortened JSON
UPDATE plans SET splan = pg_store_plans_shorten(lplan);

\echo ###### tag abbreviation test
SELECT splan FROM plans WHERE id = -1;

\echo ###### JSON properties round-trip test
SELECT id FROM plans
	where pg_store_plans_jsonplan(splan) <> lplan;

\pset format unaligned
\pset tuples_only on
\pset recordsep '\n\n=======\n'
\echo  ###### format conversion tests
SELECT '### '||'yaml-short       '||title||E'\n'||
  pg_store_plans_yamlplan(splan)
  FROM plans WHERE id BETWEEN 1 AND 3 or id = 1 ORDER BY id;
\echo  ################## 
SELECT '### '||'xml-short        '||title||E'\n'||
  pg_store_plans_xmlplan(splan)
  FROM plans WHERE id BETWEEN 4 AND 6 or id = 1 ORDER BY id;

\echo  ###### text format output test
SELECT '### '||'TEXT-short       '||title||E'\n'||
  pg_store_plans_textplan(splan)
  FROM plans ORDER BY id;

\echo  ###### long-json-as-a-source test
SELECT '### '||'yaml-long JSON   '||title||E'\n'||
  pg_store_plans_yamlplan(lplan)
  FROM plans WHERE id = 1 ORDER BY id;
\echo  ################## 
SELECT '### '||'xml-long JSON    '||title||E'\n'||
  pg_store_plans_xmlplan(lplan)
  FROM plans WHERE id = 1 ORDER BY id;
\echo  ################## 
SELECT '### '||'text-long JSON   '||title||E'\n'||
  pg_store_plans_xmlplan(lplan)
  FROM plans WHERE id = 1 ORDER BY id;

\echo  ###### chopped-source test
SELECT '### '||'inflate-chopped  '||title||E'\n'||
  pg_store_plans_jsonplan(substring(splan from 1 for char_length(splan) / 3))
  FROM plans WHERE id BETWEEN 16 AND 18 ORDER BY id;
\echo  ################## 
SELECT '### '||'yaml-chopped     '||title||E'\n'||
  pg_store_plans_yamlplan(substring(splan from 1 for char_length(splan) / 3))
  FROM plans WHERE id BETWEEN 19 AND 21 ORDER BY id;
\echo  ################## 
SELECT '### '||'xml-chopped      '||title||E'\n'||
  pg_store_plans_xmlplan(substring(splan from 1 for char_length(splan) / 3))
  FROM plans WHERE id BETWEEN 22 AND 24 ORDER BY id;
\echo  ################## 
SELECT '### '||'text-chopped     '||title||E'\n'||
  pg_store_plans_textplan(substring(splan from 1 for char_length(splan) / 3))
  FROM plans WHERE id BETWEEN 25 AND 27 ORDER BY id;

\echo ###### shorten test
SELECT '### '||'shorten          '||title||E'\n'||
  pg_store_plans_shorten(lplan)
  FROM plans WHERE id = -2 ORDER BY id;
\echo ###### normalize test
SELECT '### '||'normalize        '||title||E'\n'||
  pg_store_plans_normalize(lplan)
  FROM plans ORDER BY id;

